
'Bouncy Pony Balls
'My Little Game Jam Entry Submission by BlitzProg

'Compiled with Monkey V63
'http://www.monkeycoder.co.nz/Store/_index_.php

'E-Mail: blitzprog@blitzspace.com

Import mojo

Function Main()
	New BPB()
End Function

Class BPB Extends App
	Global gametick
	Global player:ball
	Global camerax#,cameray#
	
	Global Z:Image
	Global twi:Image
	Global unicorn:Image
	Global pegasus:Image
	Global earth:Image
	Global explode:Image
	Global mask:Image
	
	Global mainscreen:Image
	Global instructions:Image
	Global commands:Image
	Global commandbutton:Image[4]
	
	Global gameover:Image
	
	Global gametype:Image[]
	
	Global score
	
	Global gamestatus = 0
	
	Method OnCreate()
		Z=LoadImage("Z1007.png")
		twi=LoadImage("main.png")
		unicorn=LoadImage("unicorn.png")
		pegasus=LoadImage("pegasus.png")
		earth=LoadImage("normal.png")
		explode=LoadImage("explode.png")
		mask=LoadImage("main.png")
		
		mainscreen=LoadImage("mainscreen.png")
		instructions=LoadImage("instructions.png")
		
		commands=LoadImage("buttons.png")
		button.init()
		
		gameover = LoadImage("gameover.png")
		
		gametype=[twi,unicorn,pegasus,earth]
		
		gametick=0
		SetUpdateRate 50
		
		'player = New ball(320,240,0,20,2,0.2,0)
	
		'Local i
		'For i=0 To 10
		'	New ball(300,160,0,10,1,0.1,1)
		'Next
		newgame()
		ball.autoplay=1
		
		'New platform(320,240,500)
		'New platform(320,240,100)
		
	End Method
	
	Method newgame()
		ball.flush()
		platform.flush()
		ball.limit2 = New platform(320,240,500)
		New platform(320,240,300)
		ball.limit1 = New platform(320,240,100)
		player = New ball(320,240,0,20,2,0.2,0)
		
		'New ball(320,240,0,10,1,0.1,3)
		gametick=0
	End Method
	
	Method OnUpdate()
		Local mx=MouseX()
		Local my=MouseY()
		Local md=MouseDown(0)
		Local mc=MouseHit(0)
		
	'	gametick=gametick+1
		If gamestatus=0
			If button.updatebutton(1,0,420,mx,my,mc) Then gamestatus=1
			If button.updatebutton(0,340,420,mx,my,mc)
				gamestatus=2
				ball.autoplay=0
				newgame()
			Endif
		Elseif gamestatus=1
			If button.updatebutton(2,0,420,mx,my,mc) Then gamestatus=0
		Endif
		
		
		If ball.autoplay
			If player.status > 50 Then newgame() Else updategame(mx,my,md)
		Else 
			If KeyHit(KEY_ENTER) Then newgame()
			
			If KeyDown(KEY_SPACE) Then ball.main.requestshield = True Else ball.main.requestshield = False
			If player.status<99
				updategame(mx,my,md)
			Else
				If button.updatebutton(3,170,380,mx,my,mc)
					newgame()
				Elseif KeyHit(KEY_ESCAPE)
					newgame()
					gamestatus=0
					ball.autoplay=1
				Endif
			Endif
		Endif
	End Method
	
	Method updategame(mx,my,md)
	
		gametick=gametick+1
		ball.updateall(mx,my,md,0)
		ball.moveall()
		
		Local delay=48
		If gametick>1500 delay=40
		If gametick>3000 delay=32
		If gametick>4500 delay=24
		If gametick>6000 delay=16
		If gametick>7500 delay=8

		If (gametick Mod delay = 0) Then ball.generate()
	End Method
	
	Method OnRender()
		Cls 128,0,0
		
		camerax = player.x-320
		cameray = player.y-240
		
		platform.renderall(camerax,cameray)
		ball.renderall(camerax,cameray)
		
	
		
		If player.status=99
			SetAlpha 0.75
			SetColor 0,0,0
			DrawRect 0,0,640,480
			SetAlpha 1
			SetColor 255,255,255
		
			SetColor 0,0,0
			DrawImage gameover,10,10
			SetColor 255,255,255
			DrawImage gameover,0,0
			DrawText "You lasted: "+timing(gametick),150,330
			DrawText "And you have sent "+ball.kills+" ponies back to Equestria.",150,350
			
			DrawText "Click retry or hit ENTER to try again",200,430
			DrawText "Press Escape to return to main menu",200,450
			
			button.drawbutton(3,170,380)
		Else
			If ball.autoplay=0
				DrawText "Survival Time : "+timing(gametick),10,10
				DrawText "Ponies released : "+ball.kills,10,30
				drawbox(10,50,251,13)
				If ball.main.shield>0
					SetColor 255,0,0
					DrawRect 11,52,ball.main.shield,10
					SetColor 255,255,255
				Endif 
				
			Else
				If gamestatus=0
					SetColor 0,0,0
					DrawImage mainscreen,10,10
					SetColor 255,255,255
					DrawImage mainscreen,0,0
					
					button.drawbutton(1,0,420)
					button.drawbutton(0,340,420)
				Endif
				
				If gamestatus=1
					SetAlpha 0.75
					SetColor 0,0,0
					DrawRect 0,0,640,480
					SetAlpha 1
					SetColor 255,255,255
					DrawImage instructions,0,0
					button.drawbutton(2,0,420)
				Endif
				
				
				
			Endif
		Endif
	End Method
End

Class ball
	Field kind

	Field x#
	Field y#
	Field angle#
	Field dx#
	Field dy#
	
	Field size#
	
	Field kuzyp
	Field kuzypload
	
	Field mass#
	Field speed#
	
	Field status=0
	
	Field shield=250
	Field requestshield
	Field shielded
	
	Global all:ball[2048]
	Global count=0
	
	Global main:ball
	
	Global limit1:platform
	Global limit2:platform
	
	Global kills
	
	Global autoplay
	
	Function flush()
		main=Null
		limit1=Null
		limit2=Null
		kills=0
		Local i
		For i=0 To count-1
			all[i]=Null
		Next
		count=0
	End Function
	
	Function generate()
		Local angle#=Rnd(360)
		
		Local specy=Int(Rnd(50)) Mod 3
		
		Local distance#=Rnd(limit2.size-limit1.size)+limit1.size
		
		Local posx# = Cos(angle)*distance + limit2.x
		Local posy# = Sin(angle)*distance + limit2.y
		
		Local size#=Rnd(20)+10
		Local mass#=Float(size)/10
		Local speed#=Rnd(0.3)+0.1
		
		If specy=1
			mass=mass*0.5
			speed=speed*1.5
		Endif
		
		If specy=2
			mass=mass*1.5
			speed=speed*0.5
		Endif
			
		
		
		New ball(posx,posy,Rnd(360),size,mass,speed,1+specy)
	End Function
		
	
	Method New(px#,py#,a#,s#,m#,sp#,k)
		x=px;y=py;angle=a;size=s;kind=k;mass=m;speed=sp
		all[count]=Self
		count=count+1
		status=0
		If kind=0 Then main=self
	End Method
	
	Method draw(cx#,cy#)
		Local a# = angle + (Cos(BPB.gametick*8)*2)
		
		Local usedsize#=size
		If status<50
			usedsize=size*(1+(Float(50-status)/5))
		Endif
		SetAlpha 1-(Float(Abs(status-50))/50)
		
		If kind=0
			drawrotatedscaled(BPB.gametype[0],x-cx,y-cy,1.5*usedsize/20,a)
		Else
			drawrotatedscaled(BPB.gametype[kind],x-cx,y-cy,1.5*usedsize/20,a)
		Endif
		
		SetAlpha 1
		
		If status>50
			If kind=0
				usedsize=Float(status-50)/5.0
			Else
				usedsize=Float(25.0-Abs(status-75.0))/20.0
			Endif
			drawrotatedscaled(BPB.explode,x-cx,y-cy,usedsize,a+(BPB.gametick*4))
		Endif
		
		If shielded
			SetColor 255,0,0
			SetAlpha 0.5
			DrawCircle x-cx,y-cy,size*2
			SetAlpha 1
			SetColor 255,255,255
		Endif
	End Method
	
	Function renderall(cx#,cy#)
		Local i
		For i=0 To count-1
			If all[i].status >= 100 Continue
			all[i].draw(cx,cy)
		Next
	End Function
	
	Method move()
		If status<50 Then Return
		x=x+dx
		y=y+dy
		dx=0.98*dx
		dy=0.98*dy
	End Method
	
	Method trust()
		If status<>50 Then Return
		Local addx#=Cos(angle)*speed
		Local addy#=Sin(angle)*speed
		
		dx+=addx
		dy+=addy
	End Method
	
	Method outofboundary()
		Local distx# = x-limit2.x
		Local disty# = y-limit2.y
		Local maxsize# = limit2.size - size
		
		If (distx*distx) + (disty*disty) > (maxsize*maxsize) Return True
		Return False
	End Method
	
	Method update(mx,my,md,md2)
		If status<>50 Or outofboundary() Then status+=1
		If autoplay
			angle=ATan2(limit2.y+(Sin(BPB.gametick)*100)-y,limit2.x+(Cos(BPB.gametick)*100)-x)
			trust()
			
		Else
			shielded=False
			If shield>0 And requestshield And status=50 Then shielded=True
			If shielded=True shield=shield-1
			angle=ATan2(my-240,mx-320)
			If md Then trust()
		Endif
	End Method
	
	Method updateai()
		If status<>50 Or outofboundary() Then status+=1
		If status=51 Then kills+=1
		requestshield=False
		If shield>0 And kind=1 Then requestshield = True
		shielded=False
		If shield>0 And requestshield And status=50  Then shielded=True
		If shielded=True shield=shield-1
		
		angle=ATan2(main.y-y,main.x-x)
		trust()
	End Method
	
	Function updateall(mx,my,md,md2)
		Local i
		For i=0 To count-1
			If all[i].status >= 100 Continue
			If all[i].kind=0 Then all[i].update(mx,my,md,md2) Else all[i].updateai()
		Next
	End Function
	
	Function moveall()
		Local i
		For i=0 To count-1
			If all[i].status >= 100 Continue
			all[i].move()
			all[i].collide()
		Next
	End Function
	
	Method colliding(b:ball)
		If b=Self Return False
		If b.status<>50 Return False
		Local minimum# = size+b.size
		Local distx#=x-b.x
		Local disty#=y-b.y
		
		Local sq# = minimum*minimum
		Local dist# = (distx*distx) + (disty*disty)
		
		If dist <= sq Return True
		Return False
	End Method
	
	Method bounce(addx#,addy#)
		'If main=Self Return
		If shielded Return
		dx+=addx
		dy+=addy
	
	End Method
	
	Method collide()
		If status<>50 Return False
		Local i
		For i=0 To count-1
			Local b:ball=all[i]
			If colliding(b)
				Local normal# = ATan2(b.y-y,b.x-x)
				
				Local distx#=x-b.x
				Local disty#=y-b.y
				Local dist# = Sqrt((distx*distx) + (disty*disty))
				Local cdist# = size+b.size
				
				Local mdist1# = (cdist-dist)*(b.mass / (mass+b.mass))
				Local mdist2# = (cdist-dist)*(mass / (mass+b.mass))
				
				x+=mdist1*Cos(normal+180)
				y+=mdist1*Sin(normal+180)
				b.x+=mdist2*Cos(normal)
				b.y+=mdist2*Sin(normal)
				
				Local nx#=Cos(normal)
				Local ny#=Sin(normal)
				Local a1#=(dx*nx) + (dy*ny)
				Local a2#=(b.dx*nx) + (b.dy*ny)
				
				Local opt# = (2.0*(a1-a2)) / (b.mass+mass)
				
				bounce(-opt*nx*b.mass*1.2,-opt*ny*b.mass*1.2)
				b.bounce(opt*nx*b.mass*1.2,opt*ny*b.mass*1.2)
				
				'dx-=opt*nx*b.mass*1.2
				'dy-=opt*ny*b.mass*1.2
				
				'b.dx+=opt*nx*mass*1.2
				'b.dy+=opt*ny*mass*1.2
				'Local movedist = 
				
				
			Endif
		Next
	End Method
End Class

Class platform
	
	Field x#,y#,size#
	
	Global all:platform[32]
	Global count=0
	
	Function flush()
		Local i
		For i=0 To count-1
			all[i]=Null
		Next
		count=0
	End Function
	
	Method New(px#,py#,s#)
		x=px;y=py;size=s
		all[count]=Self
		count=count+1
	End Method
	
	Method draw(cx,cy)
		DrawCircle x-cx,y-cy,size
	End Method
	
	Function renderall(cx,cy)
		Local i
		SetColor 0,128,255
		SetAlpha 0.5
		For i=0 To count-1
			all[i].draw(cx,cy)
		Next
		SetColor 255,255,255
		SetAlpha 1
	End Function

End Class

Class button
	Global width=300,height=45
	Global list:Image
	
	Field id
	Field hover
	Field img:Image
	
	Global all:button[4]
	
	Function init()
		list = BPB.commands
		Local i
		For i=0 To 3
			all[i] = New button
			all[i].id=i
			all[i].img = list.GrabImage(50,5+(50*i),300,45)
		Next
	End Function
	
	Method draw(x,y)
		If hover Then SetColor 255,0,0 Else SetColor 255,255,255
		DrawImage img,x,y
		SetColor 255,255,255
	End Method
	
	Function drawbutton(i,x,y)
		all[i].draw(x,y)
	End Function
	
	Method update(x,y,mx,my,mc)
		hover=false
		If x<mx And mx<(x+width) And y<my And my<(y+height) Then hover=True
		
		If mc And hover Then Return True
		Return False
	End Method
	
	Function updatebutton(i,x,y,mx,my,mc)
		Return all[i].update(x,y,mx,my,mc)
	End Function
	
End Class

'additionnal stuff from personnal librairies
	
Function drawrotatedscaled(img:Image,px#,py#,scale#,angle#)
	If scale=0 Return
	Local a#=-angle-90
	
	PushMatrix()
	Translate px, py
	Rotate a
	Scale scale,scale
	Translate -px, -py
	img.SetHandle(32,32)
	DrawImage img,px,py
	PopMatrix()
End Function

Function timing$(octet)
	If octet=1 Then octet=0
	Local totalcenti=octet*2
	Local mins=Int(totalcenti/6000)
	Local secs=(totalcenti/100)-(mins*60)
	Local centi=totalcenti-(mins*6000)-(secs*100)
	
	Local strmin$="0"+mins
	Local strsec$="0"+secs
	Local strcen$="0"+centi
	
	Local tps$= strmin[-2..] + ":" + strsec[-2..] + "'" + strcen[-2..]
	Return tps
End Function

Function drawbox(x,y,w,h)
	DrawLine x,y,x+w,y
	DrawLine x,y,x,y+h
	DrawLine x,y+h,x+w,y+h
	DrawLine x+w,y,x+w,y+h
End Function